global function placeEdenObjects

void function placeEdenObjects()
{
    PrecacheModel( $"models/eden/eden_screen_tall.mdl" )

    CreateSimpleButton( < -3046, -186, 422 >, <0, 90, 0>, "to launch yourself", Yeet1, 5.0 )
    CreateSimpleButton( <1589, -185, 422>, <0, 90, 0>, "to launch yourself", Yeet2, 5.0 )

    entity mover = CreateExpensiveScriptMoverModel( $"models/props/turret_base/turret_base.mdl", <1589 - 100, -185, 422>, <0,0,0>, SOLID_VPHYSICS, 1000 )
    mover.SetScriptName( "eden2" )

    mover = CreateExpensiveScriptMoverModel( $"models/props/turret_base/turret_base.mdl", < -3046 + 100, -186, 422 >, <0,0,0>, SOLID_VPHYSICS, 1000 )
    mover.SetScriptName( "eden1" )

    CreateNessy( <1852, -1079, 106>, <0, 90, 0>, 1 )

    CreatePhaseTeleporter( < -2040.78, 2698.2, 168.738 >, < -3305.58, 596.523, 57.2551 > )
    CreatePhaseTeleporter( <612, -1032, 68>, <612, -1170, 68> )
    CreateSarahCoffeMaker( <2101, 151, 72>, <0,270,0> )
    CreateAshPeaceKraberSeller( <472, -1032, 68>, <0,-270,0> )

    CreatePropDynamic( $"models/eden/eden_screen_tall.mdl", <472, -840, 68>, <0,180,0>, SOLID_VPHYSICS )
    CreatePropDynamic( $"models/eden/eden_screen_tall.mdl", <680, -840, 68>, <0,180,0>, SOLID_VPHYSICS )
}

void function Yeet1( entity button, entity player )
{
    if ( !IsValid( player ) || GetEntArrayByScriptName( "eden1" ).len() != 1  )
        return

    entity mover = GetEntArrayByScriptName( "eden1" )[0]
    
    player.SetOrigin( mover.GetOrigin() + <0,0,50> )
    player.SetParent( mover )
    mover.NonPhysicsMoveTo( mover.GetOrigin() + <500,0,0>, 0.2, 0, 0 )
    wait 0.2
    
    if ( IsValid( player ) )
    {
        player.ClearParent()
        player.SetVelocity( player.GetVelocity() + <600,0,200> )
    }

    mover.NonPhysicsMoveTo( mover.GetOrigin() - <500,0,0>, 0.2, 0, 0 )
}

void function Yeet2( entity button, entity player )
{
    if ( !IsValid( player ) || GetEntArrayByScriptName( "eden2" ).len() != 1  )
        return

    entity mover = GetEntArrayByScriptName( "eden2" )[0]
    
    player.SetOrigin( mover.GetOrigin() + <0,0,50> )
    player.SetParent( mover )
    mover.NonPhysicsMoveTo( mover.GetOrigin() - <500,0,0>, 0.2, 0, 0 )
    wait 0.2
    
    if ( IsValid( player ) )
    {
        player.ClearParent()
        player.SetVelocity( player.GetVelocity() + < -600,0,200 > )
    }

    mover.NonPhysicsMoveTo( mover.GetOrigin() + <500,0,0>, 0.2, 0, 0 )
}